﻿import As.myColor
// La clase myColor no se ha tenido que modificar ni tan siquiera en el nombre, ya que no hace referencia a otras clases ni afecta al comportamiento entre ambas galerías, por lo que es compartible.
// Dentro de la carpeta As/XmlIcons encontraremos el resto de clases modificadas, básicamente renombradas para que no interfieran en la galería normal, la que no usamos en el formulario.
class AHolder extends MovieClip{
	private var speed:Number = 20 //speed to resize image
	private var hw:Number = 100 //heigth and size of icons
	private var maxHeight:Number = 300 //Max available heigth on Stage
	private var maxWidth:Number = 450 //Max available width on Stage	
	private var foto:MovieClip //container for loading big photos
	private var preload:MovieClip //preloader movieClip
	private var back:MovieClip //back to perform transitions between one image and another
	private var pic:MovieClip //holder to load icons
	private var mColor : As.myColor //brigth fadein/out method
	private var cmMenu:ContextMenu  //rigth click to save
	private var icons:MovieClip //holder to load icons
	/**
	* Constructor
	*/
	// La función real es Holder, pero se modificó para poder usar la galería en dos partes sin que afecte el comportamiento que tendrá la galería de selección de plantillas en la galería simple.
	function AHolder(){	
		preload._visible = false //hides preload
		//build the context menu to save image
		// Para desactivar esta función bastará con poner en el fla la instrucción Stage.showMenu = false;
		cmMenu = new ContextMenu()
		cmMenu.customItems.push(new ContextMenuItem("Abrir en una ventana nueva", saveImage));
		cmMenu.hideBuiltInItems()
	}
	
	/*Public functions*/
	
	/**
	*  Load big images
	*  @param who name of the image	
	*/
	public function loadImage (who : String) : Void	{
			//Create container just once for loading big photos
			if(!foto) foto = this._parent.createEmptyMovieClip("foto", 1) 	
			// Aquí pondremos la url absoluta, semiabsoluta o relativa, donde encontrará las imagenes de tamaño medio, que es la que muestra al seleccionar un pic
			foto.loadMovie ("multimedia/imagen/plantillas/orig/"+ who)
			foto._visible = false			
			preload._visible = true	
			//preloading
			this.onEnterFrame = function ()
			{			
				var perc = Math.round(foto.getBytesLoaded()/foto.getBytesTotal()*100);				
				preload.barra._width = perc
				foto._visible = false
				if (perc >= 100 && foto.getBytesLoaded () > 1 && foto._width > 1)
				{
					delete this.onEnterFrame
					preload._visible = false
					var dim = checkSize(foto._width, foto._height)					
					resize (dim.w, dim.h)
					//assign contextMenu 
					foto.menu = cmMenu
					//Saves image name for contextMenu
					foto.image = who
					foto.onPress = function (){
					//getURL("javascript:NewWindow=window.open('media/imagen/plantillas/big/show.php?File="+who+"','newWin','width=500,height=400,left=200,top=200,toolbar=No,location=No,scrollbars=No,status=No,resizable=No,fullscreen=No');  NewWindow.focus();      void(0);");
					//trace (who);
					// Como las galerías no están completas usamos una imagen llamada Próximamente para todas las casillas que quedan libres, ya que no nos interesa tener menos de 16 imágenes por pantalla, si no, lo mostraría en vez de en clips, en imágenes de tamaño medio y de una en una lo que haría tedioso la selección de plantilla.
					if (who == "Proximamente.jpg"){
					_parent.output.text = "Seleccione una plantilla disponible.";
					// Así que si se selecciona esta imagen predeterminada para todos y que no es una plantilla, avisará en el fla de que se seleccione una plantilla disponible.
					}else{
					var my_str:String = who;
					var my_array:Array = my_str.split(".");
					for (var i = 0; i<my_array.length; i++) {
						// Aquí quitamos la extensión de archivo a la plantilla seleccionada.
    				//trace(my_array[i]);
					}

					//trace(targetPath(this));
					// Y pasamos su valor al cuadro de texto plantilla.
					_parent._parent.plantilla.text = my_array[0];
					_parent._parent.plantillatit.text = "Plantilla";
					_parent._parent.avisoplantilla.text = "Si desea otra plantilla use el botón borrar";
					_parent._parent.btnborrarplt._visible = true;
					_parent._parent.btnborrarplt.enabled = true;
					_parent._parent.prevFrame();}
					// Ponemos el título del cuadro plantilla, y mostramos el aviso para seleccionar otra plantilla y activamos el botón borrar.
					// Luego retornamos al fotograma anterior, para continuar con el formulario.
					
					}
					}
		}		
	}
	/**
	*  transition between previous and next image
	*  @param who name of the image	
	*/
	public function change (who : String) : Void
	{		
		foto._visible = false
		if (back._width >= hw && back._height >= hw)
		{
			var distx = back._width - hw
			var disty = back._height - hw
			var stepx = int (distx / speed)
			var stepy = int (disty / speed)
			if (stepx < 1)
			{
				//steps too small
				back._width = hw
				back._height = hw
				loadImage (who)
				return
			}
			this.onEnterFrame = function () : Void
			{
				back._width -= stepx
				back._height -= stepy
				if (back._width <= hw)
				{
					back._width = hw
					back._height = hw
					delete this.onEnterFrame
					loadImage (who)
				}
			}
		} 
		else loadImage (who)
	}
	/**
	*  Load icons
	*  @param caller is a reference to the class calling this method, because this method is recursive
	*  @param image is the name of the image to load
	*/
	public function loadIcons (caller:Object, image:String) : Void
	{
		pic.loadMovie ("multimedia/imagen/plantillas/pics/" +image)
		// En ésta ruta se encuentran las imágenes pequeñas (pics).
		pic._visible = false
		preload._visible = true
		this["nr"] = caller.getModel().getPos()
		//preloader
		this.onEnterFrame = function ()
		{			
			var perc = Math.round(pic.getBytesLoaded()/pic.getBytesTotal()*100);
			preload.barra._width = perc
			pic._visible = false
			if (perc >= 100 and pic.getBytesLoaded() > 1 && pic._width>1)
			{				
				preload._visible = false
				pic._visible = true
				//position on center, pics are resized to match one side (heigth or width) of initAHolder
				var w = pic._width
				var h = pic._height
				var cx = (w != hw) ?int ((hw - w) / 2) : 0;
				var cy = (h != hw) ?int ((hw - h) / 2) : 0;
				pic._x += cx;
				pic._y += cy
				// Color brigthness
				this.b = 12
				this.cant = 50
				this.mColor = new As.myColor (pic)
				this.mColor.setBrightOffset (this.cant)
				//overwrite onEnterFrame
				this.onEnterFrame = function ()
				{					
					this.mColor.setBrightOffset (this.cant -= this.b)
					if (this.cant <= 10)
					{
						//set rollOver, RollOut, Press
						this.onRollOver = function ()
						{
							this.mColor.setBrightOffset (50)
						}
						this.onRollOut = function ()
						{
							this.mColor.setBrightOffset (3)
						}
						this.onPress = function ()
						{
                        this._parent.controller.changeView("single")
                        this._parent.controller.loadPhoto(this.nr)
                        this._parent.icons._visible = true
                        this._parent.icons.enabled = true
                        }
						delete this.onEnterFrame
						var model = caller.getModel()
						if (model.hasNext())  {
							model.next()
							caller.showIcons ()
						} 	else {
							//Last item in model
							this._parent.pag.reset()
							var last = model.getCantItems()
							var first = (last%caller.getIconsPerPage()!=0)?caller.getIconsPerPage()*Math.floor(last/caller.getIconsPerPage())+1 : caller.getIconsPerPage()*Math.floor(last/caller.getIconsPerPage()-1)+1
							this._parent.output.text = first+" de "+last+" de un total de "+last
							// Esta modificación muestra un aviso debajo de la barra de la galería, el cuadro de texto marcado con el número dos en la imagen que está encima.
							this._parent.avisooutput.text = "Haga clic sobre el icono que desee ver ampliado";
							this._parent.controller.loadPhoto(first)
						}
					}
				}
			}
		}
	}
	
	/*Private functions */
	
	/**
	*  Saves images to disk
	*  @param mc is the MovieClip holding image to save
	*/
	private function saveImage(mc:MovieClip){
			//Open in an HTML window is the safest way
			// Esta clase la modifiqué para que abriera el swf en un html creado por show.php, si alguien esta interesado en ver el código del php puede escribirme a info@cropcreativos.com, pero no lo incluyo porque no viene al caso para este tutorial.
			mc.getURL("javascript:NewWindow=window.open('multimedia/imagen/plantillas/orig/show.php?File="+mc.image+"','newWin','width="+(mc._width+20)+",height="+(mc._height+20)+",left=200,top=200,toolbar=No,location=No,scrollbars=No,status=No,resizable=No,fullscreen=No');  NewWindow.focus();      void(0);");
	}
	/**
	*  Checkif the size of image overpass max limits
	*  @param w width of the image
	*  @param h heigth of the image	
	*/
	private function checkSize(w:Number, h:Number):Object{		
		if(h<=maxHeight && w<=maxWidth) {
			return {h:h, w:w}
		} else { //recalculate dimensions, overpass boundaries			
			var orientation =(w>h)?"w" : "h"
			if(orientation=="h"){
				var per = int((maxHeight*100)/h)
				var newWidth = int((w*per)/100)
				return {h:maxHeight, w:newWidth}
			} else {
				var per = int((maxWidth*100)/w)
				var newHeight = int((h*per)/100)
				return {h:newHeight, w:maxWidth}				
			}
		}
	}
	/**
	*  Resize background in the transition routine between one image and another
	*  @param w width of the image
	*  @param h heigth of the image	
	*/
	private function resize (w : Number, h : Number) : Void
	{				
		var c = 0
		var stepx = int (w / speed)
		var stepy = int (h / speed)
		this.onEnterFrame = function ()
		{			
			back._width += stepx
			back._height += stepy		
			if (back._width >= w)
			{				
				back._width = w
				back._height = h
				var p = back.getBounds (_parent)
				foto._x =  p.xMin 
				foto._y = p.yMin
				//Match photo size with background size
				foto._width = back._width
				foto._height = back._height
				foto._visible = true
				var b = 1, cant = 50
				mColor = new As.myColor (foto)
				mColor.setBrightOffset (cant)
				//overwrites onEnterFrame
				this.onEnterFrame = function ()
				{
					mColor.setBrightOffset (cant -= b)
					if (cant <=0)
					{						
						delete this.onEnterFrame						
					}
				}
			}
		}
	}
}			