﻿class Pages extends MovieClip
// Esta clase tambien es compartible, por lo que no se a modificado el nombre ni nada, ya que no interfiere en ninguna de las dos galerias.
{
	private var selected : Number = 0; // which foto is selected, 0 by default
	//Formats for numbers
	private var tover : TextFormat;
	private var tnormal : TextFormat;
	private var t : MovieClip; //shorcut to current timeline
	private var controller //Reference to the Controller. No datatype to allow reuse
	
	/**
	* Constructor
	*/
	function Pages ()
	{
		tover = new TextFormat ()
		tnormal = new TextFormat ()
		tover.color = 0xFF6600;
		tnormal.color = 0x666666;		
		t = this;
	}
	/* Public functions */
	 
	/**
	*  Needs to interact with controller
	*  @param controller is a the Controller class
	*/
	public function setController(controller){
		this.controller=controller
	}
	/**
	*  Update is broadcasted from model each time it changes current image
	*  @param m is the model, not datatype to allow reuse
	*/
	public function update(m):Void{		
		reset()
		//highligth selected photo number
		over(t.pages ["nr" +m.getPos()])
	}
	
	/**
	*  Display photos numbers. Access the model trough the controller
	*  @param page is the number of page
	*/
	public function displayNumbers (page : Number) : Void 
	{			
		var perPage = controller.getView().getIconsPerPage()
		var i = perPage*(page-1)+1;
		var last = (perPage*page<controller.getModel().getCantItems())?perPage*page : controller.getModel().getCantItems();		
		var pos:Number = 0;
		var m : MovieClip
		t.createEmptyMovieClip ("pages", 1)
		//Put numbers
		t.onEnterFrame = function ()
		{
			if (i <= last)
			{
				var p = t.pages.attachMovie ("nro", "nr" + i, i , 
				{
					_y : 0
				});
				p.count = pos
				p._x =pos++ * t.pages ["nr" + i]._width;
				p.pags.text = i ;
				p.nr = i;				
				//Numbers callbacks
				p.onPress = function () : Void 
				{
					this._parent._parent.pressed (this.nr);
					this._parent._parent._parent.icons._visible = true
                    this._parent._parent._parent.icons.enabled = true
				};
				p.onRollOver = function () : Void 
				{
					this._parent._parent.over (this);
				};
				p.onRollOut = function () : Void 
				{
					if(this._parent._parent.selected!=this.nr)
					{					
						this._parent._parent.normal (this);
					}
				};				
				i ++;
			} else 
			{
				//highligth selected photo
				var sel = (controller.getModel().getPos()!=0)?controller.getModel().getPos() : 1				
				this.over (this.pages["nr"+sel])
				delete this.onEnterFrame;
			}
		};
	}
	/* Private functions */
	
	/**
	*  Number return to no-highlighted state
	*  @param who MovieClip who represents this number	
	*/
	private function normal (who:MovieClip) : Void 
	{
		t._parent["h"+who.count].onRollOut()
		if (selected != who.nr)
		{
			who.pags.setTextFormat (tnormal);
		}
	}
	/**
	*  Number highligh state
	*  @param who MovieClip who represents this number	
	*/	
	private function over (who:MovieClip) : Void 
	{
		who.pags.setTextFormat (tover);		
		t._parent["h"+who.count].onRollOver()
	}
	/**
	*  All numbers to black
	*/	
	private function reset ():Void	{
		
		for (var z in t.pages) t.pages [z].pags.setTextFormat (tnormal);
	}
	/**
	*  Load image when press a number
	*  @param nr the number of the image in photo array
	*/		
	private function pressed (nr : Number) : Void 
	{
		reset ();
		t.oldSelected = t.selected
		t.selected = nr;		
		// Selected nr to red
		t.pages["nr"+nr].onRollOver()
		controller.loadPhoto(nr)		
	}
}